-- ********************************
--        CREATE AUTH TABLES
-- ********************************
CREATE TABLE DB_VERSION ( 
	SYS_ID bigint identity(1,1)  NOT NULL,
	VERSION varchar(250)
)
;

CREATE TABLE MA_USER ( 
	USER_ID bigint identity(1,1)  NOT NULL,
	USERNAME varchar(250) NOT NULL,
	PASSWORD varchar(250),
	USER_TYPE smallint
)
;

CREATE TABLE DATAFLOW_USER ( 
	DF_ID bigint NOT NULL,
	USER_ID bigint NOT NULL
)
;

CREATE TABLE DATAFLOW_DB_CONNECTION ( 
	DF_ID bigint NOT NULL,
	CONNECTION_ID bigint NOT NULL
)
;

CREATE TABLE DATAFLOW_DATASET ( 
	DF_ID bigint NOT NULL,
	DS_ID bigint NOT NULL
)
;

CREATE TABLE CATEGORY_USER ( 
	CAT_ID bigint NOT NULL,
	USER_ID bigint NOT NULL
)
;

CREATE TABLE CATEGORY_DB_CONNECTION ( 
	CAT_ID bigint NOT NULL,
	CONNECTION_ID bigint NOT NULL
)
;

CREATE TABLE CATEGORY_DATASET ( 
	CAT_ID bigint NOT NULL,
	DS_ID bigint NOT NULL
)
;

ALTER TABLE DB_VERSION ADD CONSTRAINT PK_DB_VERSION 
	PRIMARY KEY CLUSTERED (SYS_ID)
;



-- ********************************
--        CREATE HEADER TABLES
-- ********************************
CREATE TABLE PARTY ( 
	PARTY_ID bigint identity(1,1)  NOT NULL,
	ID varchar(255),
	HEADER_ID bigint,
	TYPE varchar(50)
) 
;

CREATE TABLE HEADER_LOCALISED_STRING ( 
	HLS_ID bigint identity(1,1)  NOT NULL,
	TYPE varchar(50),
	HEADER_ID bigint,
	PARTY_ID bigint,
	CONTACT_ID bigint,
	LANGUAGE varchar(50),
	TEXT varchar(255)
)
;

CREATE TABLE HEADER ( 
	HEADER_ID bigint identity(1,1)  NOT NULL,
	TEST tinyint,
	DATASET_AGENCY varchar(255),
	DF_ID bigint
)
;

CREATE TABLE CONTACT_DETAIL ( 
	CD_ID bigint identity(1,1)  NOT NULL,
	CONTACT_ID bigint,
	TYPE varchar(50),
	VALUE varchar(255)
)
;

CREATE TABLE CONTACT ( 
	CONTACT_ID bigint identity(1,1)  NOT NULL,
	PARTY_ID bigint
)
;


-- *************************
--        ALTERATIONS
-- *************************
ALTER TABLE DB_CONNECTION DROP COLUMN CAT_ID;	-- now there is a N-N table for this
ALTER TABLE DB_CONNECTION DROP COLUMN OWNER;	-- now there is a FK for this (see below)
ALTER TABLE DB_CONNECTION ADD USER_ID bigint;

ALTER TABLE MAPPING_SET ADD USER_ID bigint;

ALTER TABLE DATASET ADD USER_ID bigint;

-- ********************************
--        PRIMARY KEYS
-- ********************************
ALTER TABLE MA_USER ADD CONSTRAINT PK_MA_USER 
	PRIMARY KEY CLUSTERED (USER_ID)
;

ALTER TABLE DATAFLOW_USER ADD CONSTRAINT PK_DATAFLOW_USER 
	PRIMARY KEY CLUSTERED (DF_ID, USER_ID)
;

ALTER TABLE DATAFLOW_DB_CONNECTION ADD CONSTRAINT PK_DATAFLOW_DB_CONNECTION 
	PRIMARY KEY CLUSTERED (DF_ID, CONNECTION_ID)
;

ALTER TABLE DATAFLOW_DATASET ADD CONSTRAINT PK_DATAFLOW_DATASET 
	PRIMARY KEY CLUSTERED (DF_ID, DS_ID)
;

ALTER TABLE CATEGORY_USER ADD CONSTRAINT PK_CATEGORY_USER 
	PRIMARY KEY CLUSTERED (CAT_ID, USER_ID)
;

ALTER TABLE CATEGORY_DB_CONNECTION ADD CONSTRAINT PK_CATEGORY_DB_CONNECTION 
	PRIMARY KEY CLUSTERED (CAT_ID, CONNECTION_ID)
;

ALTER TABLE CATEGORY_DATASET ADD CONSTRAINT PK_CATEGORY_DATASET 
	PRIMARY KEY CLUSTERED (CAT_ID, DS_ID)
;

ALTER TABLE PARTY ADD CONSTRAINT PK_PARTY 
PRIMARY KEY (PARTY_ID) 
;

ALTER TABLE HEADER_LOCALISED_STRING ADD CONSTRAINT PK_HeaderLocalisedString 
	PRIMARY KEY CLUSTERED (HLS_ID)
;

ALTER TABLE HEADER ADD CONSTRAINT PK_HEADER 
	PRIMARY KEY CLUSTERED (HEADER_ID)
;

ALTER TABLE CONTACT_DETAIL ADD CONSTRAINT PK_CONTACT_DETAIL 
	PRIMARY KEY CLUSTERED (CD_ID)
;

ALTER TABLE CONTACT ADD CONSTRAINT PK_CONTACT 
	PRIMARY KEY CLUSTERED (CONTACT_ID)
;



-- ********************************
--        FOREIGN KEYS
-- ********************************
ALTER TABLE DATAFLOW_USER ADD CONSTRAINT FK_DATAFLOW_USER_DATAFLOW 
	FOREIGN KEY (DF_ID) REFERENCES DATAFLOW (DF_ID)
ON DELETE CASCADE
;

ALTER TABLE DATAFLOW_USER ADD CONSTRAINT FK_DATAFLOW_USER_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
ON DELETE CASCADE
;

ALTER TABLE DATAFLOW_DB_CONNECTION ADD CONSTRAINT FK_DATAFLOW_DB_CONNECTION_DATAFLOW 
	FOREIGN KEY (DF_ID) REFERENCES DATAFLOW (DF_ID)
ON DELETE CASCADE
;

ALTER TABLE DATAFLOW_DB_CONNECTION ADD CONSTRAINT FK_DATAFLOW_DB_CONNECTION_DB_CONNECTION 
	FOREIGN KEY (CONNECTION_ID) REFERENCES DB_CONNECTION (CONNECTION_ID)
ON DELETE CASCADE
;

ALTER TABLE DATAFLOW_DATASET ADD CONSTRAINT FK_DATAFLOW_DATASET_DATAFLOW 
	FOREIGN KEY (DF_ID) REFERENCES DATAFLOW (DF_ID)
ON DELETE CASCADE
;

ALTER TABLE DATAFLOW_DATASET ADD CONSTRAINT FK_DATAFLOW_DATASET_DATASET 
	FOREIGN KEY (DS_ID) REFERENCES DATASET (DS_ID)
ON DELETE CASCADE
;

ALTER TABLE CATEGORY_USER ADD CONSTRAINT FK_CATEGORY_USER_CATEGORY 
	FOREIGN KEY (CAT_ID) REFERENCES CATEGORY (CAT_ID)
ON DELETE CASCADE
;

ALTER TABLE CATEGORY_USER ADD CONSTRAINT FK_CATEGORY_USER_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
ON DELETE CASCADE
;

ALTER TABLE CATEGORY_DB_CONNECTION ADD CONSTRAINT FK_CATEGORY_DB_CONNECTION_CATEGORY 
	FOREIGN KEY (CAT_ID) REFERENCES CATEGORY (CAT_ID)
ON DELETE CASCADE
;

ALTER TABLE CATEGORY_DB_CONNECTION ADD CONSTRAINT FK_CATEGORY_DB_CONNECTION_DB_CONNECTION 
	FOREIGN KEY (CONNECTION_ID) REFERENCES DB_CONNECTION (CONNECTION_ID)
ON DELETE CASCADE
;

ALTER TABLE CATEGORY_DATASET ADD CONSTRAINT FK_CATEGORY_DATASET_CATEGORY 
	FOREIGN KEY (CAT_ID) REFERENCES CATEGORY (CAT_ID)
ON DELETE CASCADE
;

ALTER TABLE CATEGORY_DATASET ADD CONSTRAINT FK_CATEGORY_DATASET_DATASET 
	FOREIGN KEY (DS_ID) REFERENCES DATASET (DS_ID)
ON DELETE CASCADE
;

ALTER TABLE PARTY ADD CONSTRAINT FK_PARTY_HEADER 
    FOREIGN KEY (HEADER_ID) REFERENCES HEADER (HEADER_ID)
ON DELETE CASCADE
;


ALTER TABLE HEADER_LOCALISED_STRING WITH NOCHECK ADD CONSTRAINT FK_HEADER_LOCALISED_STRING_CONTACT 
	FOREIGN KEY (CONTACT_ID) REFERENCES CONTACT (CONTACT_ID)
;

ALTER TABLE [dbo].[HEADER_LOCALISED_STRING] NOCHECK CONSTRAINT [FK_HEADER_LOCALISED_STRING_CONTACT]
;

ALTER TABLE HEADER_LOCALISED_STRING WITH NOCHECK ADD CONSTRAINT FK_HEADER_LOCALISED_STRING_HEADER 
	FOREIGN KEY (HEADER_ID) REFERENCES HEADER (HEADER_ID)
;

ALTER TABLE [dbo].[HEADER_LOCALISED_STRING] NOCHECK CONSTRAINT [FK_HEADER_LOCALISED_STRING_HEADER]
;

ALTER TABLE HEADER_LOCALISED_STRING ADD CONSTRAINT FK_HEADER_LOCALISED_STRING_PARTY 
	FOREIGN KEY (PARTY_ID) REFERENCES PARTY (PARTY_ID)
ON DELETE CASCADE
;

ALTER TABLE HEADER ADD CONSTRAINT FK_HEADER_DATAFLOW 
	FOREIGN KEY (DF_ID) REFERENCES DATAFLOW (DF_ID)
ON DELETE CASCADE
;

ALTER TABLE CONTACT_DETAIL ADD CONSTRAINT FK_CONTACT_DETAIL_CONTACT 
	FOREIGN KEY (CONTACT_ID) REFERENCES CONTACT (CONTACT_ID)
ON DELETE CASCADE
;

ALTER TABLE CONTACT ADD CONSTRAINT FK_CONTACT_PARTY 
	FOREIGN KEY (PARTY_ID) REFERENCES PARTY (PARTY_ID)
ON DELETE CASCADE
;

-- *******************************************
--        FOREIGN KEYS FROM ALTERATIONS
-- *******************************************
-- New field of DB_CONNECTION, the USER_ID is FK
ALTER TABLE DB_CONNECTION ADD CONSTRAINT FK_DB_CONNECTION_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
	ON DELETE CASCADE
;
-- New field of MAPPING_SET, the USER_ID is FK
ALTER TABLE MAPPING_SET ADD CONSTRAINT FK_MAPPING_SET_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
	ON DELETE CASCADE
;
-- New field of DATASET, the USER_ID is FK
ALTER TABLE DATASET ADD CONSTRAINT FK_DATASET_MA_USER 
	FOREIGN KEY (USER_ID) REFERENCES MA_USER (USER_ID)
	ON DELETE CASCADE
;

-- ********************************************************
--        DEFAULT VALUES for existind and new fields
-- ********************************************************
-- Categories and dataflows may belong to DB_CONNECTIONS, DATASETS and MA_USERS.
-- Since we only know about the existence of a user, the admin, everything will
-- be set to the admin.
INSERT INTO DB_VERSION (VERSION) VALUES ('2.0')
;
INSERT INTO MA_USER (USERNAME, PASSWORD, USER_TYPE) VALUES ('admin', '', 1)
;
UPDATE DB_CONNECTION SET USER_ID = 1
;
UPDATE MAPPING_SET SET USER_ID = 1
;
UPDATE DATASET SET USER_ID = 1
;


--TRIGGERS
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[TRG_DEL_HEADER_DEL_HLS]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER [dbo].[TRG_DEL_HEADER_DEL_HLS] ON [dbo].[HEADER] FOR DELETE 
AS 
    DELETE 
FROM HEADER_LOCALISED_STRING 
WHERE HEADER_ID IN 
( 
SELECT HEADER_ID 
FROM DELETED 
) 
'
;

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[TRG_DEL_CONTACT_DEL_HLS]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER [dbo].[TRG_DEL_CONTACT_DEL_HLS] ON [dbo].[CONTACT] FOR DELETE 
AS 
    DELETE 
FROM HEADER_LOCALISED_STRING 
WHERE CONTACT_ID IN 
( 
SELECT CONTACT_ID 
FROM DELETED 
) '
;